﻿using System;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Xml.Linq;

namespace BingExplorer.Services
{
    public class BingImagesClient
    {

        public event EventHandler<LoadCompletedEventArgs> LoadCompleted;

        public void LoadAsync()
        {
            WebClient client = new WebClient();
            client.OpenReadCompleted += client_OpenReadCompleted;
            client.OpenReadAsync(new Uri("http://pipes.yahoo.com/pipes/pipe.run?_id=d73ebe485bc2cb5a8f357e624d325440&_render=rss"));
        }

        private void client_OpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {
            if (e.Error != null)
            {
                OnLoadCompleted(new LoadCompletedEventArgs(e.Error));
                return;
            }

            try
            {
                // Parserizzo l'XML e recupero gli URI
                BingImage[] images = ParseXML(e);
                OnLoadCompleted(new LoadCompletedEventArgs(images));
            }
            catch (Exception ex)
            {
                OnLoadCompleted(new LoadCompletedEventArgs(ex));
            }
        }

        private static BingImage[] ParseXML(OpenReadCompletedEventArgs e)
        {
            System.Threading.Thread.Sleep(2000);

            return XElement.Load(e.Result)
                .Descendants("item")
                .Select(ec => new BingImage(
                                  ec.Element("title").Value,
                                  ec.Element("author").Value,
                                  ec.Element("link").Value,
                                  (DateTime) ec.Element("pubDate"))
                ).ToArray();
        }

        protected virtual void OnLoadCompleted(LoadCompletedEventArgs e)
        {
            EventHandler<LoadCompletedEventArgs> handler = LoadCompleted;
            if (handler != null) handler(this, e);
        }
    }
}
